const app = getApp();
const { goodsApi, DFSImg, $themeToLink,tool } = app;
const componentOptions = {
  // 组件选项
  options: {
    multipleSlots: true
  },
  behaviors: [],
  properties: {
    datas: {
      type: Object
    },
    datasIndex:{
      type: Number,
      value:0,
      observer: function () {
        // console.log('aaa');
        // this.init()
      }

    },
    goodsListIndex:{
      type:Number,
      value:0,
    },
  },
  // 组件数据
  data: {
    isPageHidden: false, // 页面是否处于隐藏状态
    titleIcon: "",
    classificationLoadPage: 1,
    classificationLoadNum: 10,
    queryProductInfoLoading: false,
    loading: false,
    finished: false,
    goodsList:[],
    storageGoodsList:[],
    storageDatasList:[],
    pageSize:10,
    pageNum:1,
    pageGoodsList:[],
    loadingFlag:true,
    wheatherLazyloading:false
  },
  // 数据监听器
  observers: {},
  // 组件生命周期
  lifetimes: {
    created() {},
    ready() {
      this.init();
    },
    moved() {},
    detached() {}
  },
  attached() {},
  definitionFilter() {},
  // 页面生命周期
  pageLifetimes: {
    // 页面被展示
    show() {
      const { isPageHidden } = this.data;

      // show事件发生前，页面不是处于隐藏状态时
      if (!isPageHidden) {
        return;
      }

      // 重新执行定时器等操作
    },
    // 页面被隐藏
    hide() {
      this.setData({
        isPageHidden: true
      });

      // 清除定时器等操作
    },
    // 页面尺寸变化时
    resize() {}
  },
  // 组件方法
  methods: {
    init() {
      let {
        goodsType,
        goodsSource,
        angleSignImg,
        titleIcon
      } = this.data.datas.componentData;
      angleSignImg = DFSImg(angleSignImg,150,150,1);
      if (titleIcon) {
        titleIcon = DFSImg(titleIcon);
      }
      this.setData({
        "data.datas.componentData.angleSignImg": angleSignImg,
        titleIcon
      });
      console.log(this.data.titleIcon, "----------------------------68");
      if (goodsType == 0) {
        if (goodsSource == "classify") {
          //商品分类
          this.getProductList(1, 1);
        } else {
          //指定商品
          this.getProductList(2);
        }
      } else if (goodsType == 1) {
        if (goodsSource == "classify") {
          //商品分类
          this.getInterList(1);
        } else {
          //指定商品
          this.getInterList(2);
        }
      }
    },
    getProductList(code, type) {
      let { goodsList, goodsSort } = this.data.datas.componentData;
      let {
        classificationLoadPage,
        loading,
        finished,
        queryProductInfoLoading
      } = this.data;
      if (queryProductInfoLoading == true) {
        return;
      }
      this.setData({ queryProductInfoLoading: true });
      // type 1初始化 2滚动加载
      //分类查
      if (code == 1) {
        if (type == 1) {
          classificationLoadPage = 1;
        } else {
          classificationLoadPage++;
          loading = true;
        }
        this.setData({ classificationLoadPage, loading });
        let query = {
          categoryId: this.data.datas.componentData.categoryId,
          page: this.showRowNum() ? classificationLoadPage : 1,
          rows: this.showRowNum()
            ? this.data.classificationLoadNum
            : this.getItemNum(),
          sortColumn: goodsSort,
          sortType: goodsSort != 2 ? 1 : 0,
          whetherShowSoldOutGoods: this.data.datas.componentData
            .whetherShowSoldOutGoods,
          whetherQueryCollectCount: true,
          whetherUseVirtualSalesQty: true,
          whetherUseVirtualCollectCount: true,
          whetherFindDistributionCommission: this
            .whetherFindDistributionCommission,
          whetherFindRecommendedCardFlag: this.data.datas.componentData.vipPrice
            ? 1
            : 0,
          whetherShowGoodsDefaultTagFlag: this.data.datas.componentData
            .marketingTag
            ? 1
            : 0,
          whetherFindMultiShopFlag: 1
        }; // 当前页 // 一页多少条 //查询销售数量 //查询收藏数 //是否使用虚拟销售数量 //是否使用虚拟收藏人数 //是否查询商品佣金（0：不查询，1：展示，为空不查佣金） //是否查询会员价  1是  0否 //是否展示营销标签  1是  0否 //是否查询多商户   //商城使用
        goodsApi.queryProductInfo(query).then(res => {
          this.setData({ loading: false, queryProductInfoLoading: false });
          if (res.data.code == 200) {
            let goodsLists = res.data.data.list;
            if (type == 1) {
              goodsList = goodsLists;
            } else {
              goodsList = [...goodsList, ...goodsLists];
            }
            if (goodsLists && goodsLists.length < 10) {
              this.setData({ finished: true });
            }
            this.goodsListVal(goodsList, type);
          }
        });
      } else {
        // 商品产品详情
        let terminalProductIds = goodsList.map(element => {
          return element.terminalProductId;
        });
        if (terminalProductIds.length == 0) {
          return;
        }
        let briefQuery = {
          sortColumn: goodsSort,
          sortType: goodsSort != 2 ? 1 : 0,
          page: 1,
          rows: terminalProductIds.length,
          terminalProductIds: terminalProductIds,
          whetherShowSoldOutGoods: app.shop_configuration.whetherShowSoldOutGoods
        }; // 当前页 // 一页多少条
        this.briefProduct(briefQuery);
      }
    },
    async briefProduct(query) {
      await goodsApi.queryBriefProductInfo(query).then(res => {
        if (res.data.code == 200) {
          let data = res.data.data.list;
          let ids = data.map(element => {
            let goodsList = this.render ? res.data.list : res.data.data.list;
            return element.terminalProductId;
          });

          let stroageIds = []
          stroageIds[this.data.datasIndex] = ids
          wx.setStorageSync('ids', stroageIds);

          let storageDatasList = wx.getStorageSync('storageDatasList') || []
          storageDatasList.push(this.data.datas.componentData)
          wx.setStorageSync('storageDatasList', storageDatasList);

          let pageGoodsList = this.data.pageGoodsList
          pageGoodsList[this.data.datasIndex] = []
          this.setData({
            pageGoodsList
          })

          this.moreProduct();
        }
      });
    },
    async moreProduct() {
      let terminalProductIds = wx.getStorageSync('ids')[this.data.datasIndex].slice((this.data.pageNum - 1) * this.data.pageSize,this.data.pageNum * this.data.pageSize)
      let pageNum = this.data.pageNum
      pageNum += 1
      this.setData({
        pageNum
      })
      let {
        vipPrice,
        marketingTag,
        whetherFindDistributionCommission,
        goodsList
      } = this.data.datas.componentData;
      let moreQuery = {
        terminalProductIds,
        whetherQueryCollectCount: true, //查询收藏数
        whetherUseVirtualSalesQty: true, //是否使用虚拟销售数量
        whetherUseVirtualCollectCount: true, //是否使用虚拟收藏人数
        whetherFindDistributionCommission: whetherFindDistributionCommission, //是否查询商品佣金（0：不查询，1：展示，为空不查佣金）
        whetherFindRecommendedCardFlag: vipPrice ? 1 : 0, //是否查询会员价  1是  0否
        whetherShowGoodsDefaultTagFlag: marketingTag ? 1 : 0, //是否展示营销标签  1是  0否
        whetherFindMultiShopFlag: 1 //是否查询多商户   //商城使用
      };
      goodsApi.queryMoreProductInfo(moreQuery).then(res => {
        if (res.data.code == 200) {
          goodsList = res.data.data;
          if ( res.data.data.length == 0 ) this.setData({wheatherLazyloading : false})
          this.goodsListVal(goodsList, 1);
        }
      });
    },
    goodsListVal(goodsList, type) {
      console.log(goodsList, "------------goodsListVal");
      goodsList.forEach((item, index) => {
        item.marketingTag = item.defaultTags
          ? this.filtermark(
              item.defaultTags,
              this.data.datas.componentData.marketingTagList
            )
          : [];
        item.shopLogoUrl = DFSImg(item.shopLogoUrl);
        item.coverImage = DFSImg(item.coverImage, 400, 400, 1);
        item.productImgUrl = DFSImg(item.productImgUrl, 400, 400, 1);
        item.loadState = false
        item.loadProductImgUrl = ""
        item.minPrice = Number(item.minPrice).toFixed(2);
        item.qty = Number(item.qty);
        item.saleQty = item.saleQty ? Number(item.saleQty) : 1;
        item.totalCollectionCount = Number(item.totalCollectionCount) || 0;
        item.minPriceAfterRecommendedCardPriceTable = item.minPriceAfterRecommendedCardPriceTable
          ? Number(item.minPriceAfterRecommendedCardPriceTable)
          : "";
        item.minProductGoodsCommission = item.minProductGoodsCommission
          ? Number(item.minProductGoodsCommission).toFixed(2)
          : 0;
        item.minGoodsSuggestedRetailPrice = item.minGoodsSuggestedRetailPrice
          ? Number(item.minGoodsSuggestedRetailPrice).toFixed(2)
          : "";
        item.showVipPrice = this.showVipPrice(item, index);
        item.showVipTag = this.showVipTag(item, index);
        if (item.saleTime) {
          item.getSaleTime = 0;
          item.getSaleTime = this.getSaleTime(item.saleTime);
        }
      });
      var that = this

      let pageGoodsList = that.data.pageGoodsList
      pageGoodsList[that.data.datasIndex].push(...goodsList)

      this.setData({
        "datas.componentData.goodsList": goodsList,
        // goodsList
        pageGoodsList,
        loadingFlag:true
      },function () {
        wx.setStorageSync('pageGoodsList', pageGoodsList);
        this.setData({wheatherLazyloading:true})
        that.lazyloading();
        // var num = 0
        // wx.createSelectorQuery().selectAll("._goods-list").boundingClientRect(function(rects){
        //   console.log(rects,'rects');
        //   rects.forEach((e,v)=>{
        //     num ++ 
        //   })
          // let storageGoodsList = wx.getStorageSync('storageGoodsList') || []
          // let storageDatasList = wx.getStorageSync('storageDatasList') || []
          // storageGoodsList.push(goodsList)
          // storageDatasList.push(that.data.datas.componentData)
          // wx.setStorageSync('storageGoodsList', storageGoodsList);
          // wx.setStorageSync('storageDatasList', storageDatasList);
          // console.log(storageGoodsList.length,num,'storageGoodsList.length');
          // let pageGoodsList = []
          // pageGoodsList[that.data.datasIndex] = storageGoodsList[that.data.datasIndex].slice(0,10)
          // wx.setStorageSync('pageGoodsList', pageGoodsList);
          // that.lazyloading();
          // that.setData({
          //   pageGoodsList
          // },function () {
          //   that.lazyloading();
          // })
          // if (storageGoodsList.length == num) {
          //   that.setData({
          //     storageGoodsList
          //   })
          //   console.log(that.data.storageGoodsList,'storageGoodsList');
          // }
        // }).exec();

        // 节点布局方案在组件嵌套层级过深测试无效
        // let goodsList = this.data.goodsList  // 获取原数据
        // goodsList.forEach((item,index)=>{
        //   wx.createIntersectionObserver().relativeToViewport({bottom: 20}).observe(`.goodsItemIndex${index}`, (ret) => {
        //     // if (ret.intersectionRatio > 0){
        //     //   group[i].show = true 
        //     // }
        //     // this.setData({ // 更新数据
        //     //   group
        //     // })
        //     console.log('1111');
        //   })
        // })
      })
      if (type == 1) {
        // 初始化
        if (this.selectComponent("#waterfallFlow")) {
          this.selectComponent("#waterfallFlow").initList(goodsList);
        }
      } else {
        // 滚动加载
        if (this.selectComponent("#waterfallFlow")) {
          this.selectComponent("#waterfallFlow").reLoadPro(goodsList);
        }
      }
    },
    // 触发图片加载
    lazyloading(){
      var that = this
      let storageDatasList = wx.getStorageSync('storageDatasList') || []
      console.log('storageDatasList',storageDatasList);
      
      let { style } = storageDatasList[that.data.datasIndex];
      let type = ''
      if(style == 'list'){
        type = 'goods-item'
      }else{
        return
      }
      // console.log(that.data.datasIndex,that.data.goodsListIndex,'index');
      // if (that.data.datasIndex != that.data.goodsListIndex) {
      //   return
      // }
      let windowHeight =  wx.getSystemInfoSync().windowHeight
      // let goodsList = that.data.goodsList
      let pageGoodsList =  wx.getStorageSync('pageGoodsList') || []
      if (!that.data.loadingFlag) {
        return
      }

      let ids = wx.getStorageSync('ids')[that.data.datasIndex]
      if (ids.length == that.data.pageGoodsList[that.data.datasIndex].length &&
        that.data.pageGoodsList[that.data.datasIndex][that.data.pageGoodsList[that.data.datasIndex].length -1].loadState == true
        ) {
        return
      }

      wx.createSelectorQuery().selectAll(`.goodsListItemIndex${that.data.datasIndex}>>>.${type}`).boundingClientRect(function(rects){
        for (let index = 0; index < rects.length; index++) {
          if (rects[index].top == 0 && rects[index].bottom == 0 && rects[index].left == 0 && rects[index].right == 0) {
            break
          }
          if (rects[index].top < windowHeight) {
            pageGoodsList[that.data.datasIndex][index].loadState = true
            // if (index == storageGoodsList[that.data.datasIndex].length && storageGoodsList[that.data.datasIndex][index].loadState == true) {
            //   loadingFlag = true
            // }
            // goodsList[index].loadState = true
          }
        }
        // rects.forEach((item,index)=>{
        //   if (condition) {
            
        //   }
        //   if (item.top < windowHeight) {
        //     goodsList[index].loadState = true
        //   }
        // })
        that.setData({
          // goodsList
          pageGoodsList
        })

        console.log(rects,that.data.pageGoodsList, pageGoodsList[that.data.datasIndex],'fff');
        wx.setStorageSync('pageGoodsList',pageGoodsList)
        // let storageGoodsList = wx.getStorageSync('storageGoodsList')[that.data.datasIndex]
        // if (storageGoodsList.length == that.data.pageGoodsList.length) {
        //   return
        // }
        if (that.data.pageGoodsList[that.data.datasIndex][that.data.pageGoodsList[that.data.datasIndex].length -1].loadState == true) {
          // let pageNum = that.data.pageNum
          // pageNum += 1
          // that.setData({
          //   pageNum
          // })
          // let newPageGoodsList = that.data.pageGoodsList
          // console.log(pageGoodsList,newPageGoodsList,'newPageGoodsList');
          // let sliceStorageGoodsList = storageGoodsList.slice((that.data.pageNum - 1) * that.data.pageSize,that.data.pageNum * that.data.pageSize)
          // newPageGoodsList[that.data.datasIndex].push(...sliceStorageGoodsList)
          // console.log(sliceStorageGoodsList,newPageGoodsList,'newPageGoodsList2');
          that.setData({
            loadingFlag:false
          })
          that.moreProduct()
          // that.setData({
          //   pageGoodsList:newPageGoodsList
          // },function(){
          //   wx.setStorageSync('pageGoodsList',pageGoodsList)
          //   that.setData({
          //     loadingFlag:true
          //   })
          //   console.log(that.data.pageGoodsList,pageGoodsList,'pageGoodsList');
          // })
          console.log('load--ok');
        }
      
      }).exec();
      // let keyStr = `datas.componentData.goodsList[${index}].loadState`;
      // this.setData({
      //   [keyStr]:true
      // })
    },
    getSaleTime(val) {
      return new Date(val.replace(/-/g, "/")).getTime() - new Date().getTime();
    },
    getItemNum() {
      //数量
      if (
        this.data.datas.componentData.style === "list" &&
        this.data.datas.componentData["goodsSource"] != "assign"
      ) {
        //网格模式
        if (
          this.data.datas.componentData.rowNum *
            this.data.datas.componentData.columnNum >=
          this.data.datas.componentData.goodsList.length
        ) {
          return this.data.datas.componentData.goodsList.length;
        } else {
          return (
            this.data.datas.componentData.rowNum *
            this.data.datas.componentData.columnNum
          );
        }
      } else {
        return this.data.datas.componentData.goodsList.length;
      }
    },
    showRowNum() {
      return (
        this.data.datas.componentData.moreShow == false &&
        this.data.datas.componentData.style == "waterfall" &&
        this.data.datas.componentData.goodsSource == "classify"
      );
    },
    filtermark(newlist, marketingTagList) {
      let list = [];
      if (newlist.length <= 0) return;
      if (marketingTagList.length > 0) {
        marketingTagList.forEach((item, index) => {
          newlist.forEach((item1, index1) => {
            if (item1 == item.key) {
              list.push(item);
            }
          });
        });
      }
      return list;
    },
    showVipPrice(item, index) {
      // 索引 0 显示价格 1显示名称
      let showFlag = false;
      let vipPrice = item["minPriceAfterRecommendedCardPriceTable"];
      if (vipPrice && Number(vipPrice) < Number(item["minPrice"])) {
        showFlag = true;
      }
      return showFlag;
    },
    showVipTag(item, index) {
      // 索引 0 显示价格 1显示名称
      let showFlag = false;
      let vipPrice = item["minPriceAfterRecommendedCardPriceTable"];
      let showTag = item["recommendedCardMinPricePriceTableName"];
      if (vipPrice && showTag && Number(vipPrice) <= Number(item["minPrice"])) {
        showFlag = true;
      }
      return showFlag;
    },
    getScroll(el) {
      // 是指定分类且不显示查看更多的瀑布流组件滚动加载
      let { goodsSource, moreShow, style } = this.data.datas.componentData;
      console.log('goodsSource, moreShow, style',goodsSource, moreShow, style);
      if (!this.data.wheatherLazyloading) return
      this.lazyloading()
      if (
        goodsSource == "classify" &&
        moreShow == false &&
        style == "waterfall"
      ) {
        this.selectComponent("#waterfallFlow").getScroll(el);
      }
    },
    // 分页加载
    onLoad() {
      console.log("---触发分页加载");
      this.getProductList(1, 2);
    },
    viewMore(e) {
      let {
        goodsType,
        style,
        categoryName,
        categoryId
      } = this.data.datas.componentData;
      let linkVal = "";
      if (goodsType != 1) {
        linkVal = `/goods/commodityMenu?categoryName=${categoryName}&categoryId=${categoryId}`;
      } else {
        linkVal = `/pointShop/productList?categoryName=${categoryName}&categoryId=${categoryId}`;
      }
      app.trackCpn(e, this.data.datas.componentName, 'ViewMore查看更多')
      $themeToLink({
        type: 1,
        link: linkVal
      });
    }
  }
};

Component(componentOptions);
